/* A Bison parser, made from parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED 1

# define	INT	257
# define	FLOAT	258
# define	ID	259
# define	STRING	260
# define	TYVAR	261
# define	CHAR	262
# define	KW_INT	263
# define	KW_RETURN	264
# define	KW_VOID	265
# define	KW_SKIP	266
# define	KW_BOOL	267
# define	KW_FLOAT	268
# define	KW_IN	269
# define	KW_EXTERN_C	270
# define	KW_STRING	271
# define	KW_FUN	272
# define	KW_IF	273
# define	KW_ELSE	274
# define	KW_WHILE	275
# define	KW_DO	276
# define	KW_FOR	277
# define	KW_CASE	278
# define	KW_SWITCH	279
# define	KW_LET	280
# define	KW_EXPORT_AS	281
# define	KW_STRUCT	282
# define	KW_OPT_STRUCT	283
# define	KW_UNION	284
# define	KW_TYPE	285
# define	KW_TYPEDEF	286
# define	KW_TRUE	287
# define	KW_FALSE	288
# define	KW_OPEN	289
# define	KW_NULL	290
# define	KW_RAISE	291
# define	KW_TRY	292
# define	KW_EXCEPTION	293
# define	KW_BREAK	294
# define	KW_CONTINUE	295
# define	KW_FINALLY	296
# define	KW_WITH	297
# define	KW_SECTION	298
# define	DOUBLECOLON	299
# define	ARROW	300
# define	GE	301
# define	LE	302
# define	EQ	303
# define	NE	304
# define	LTLT	305
# define	GTGT	306
# define	PLUS_PLUS	307
# define	MINUS_MINUS	308
# define	SLASH_EQUAL	309
# define	PLUS_EQUAL	310
# define	MINUS_EQUAL	311
# define	PERCENT_EQUAL	312
# define	STAR_EQUAL	313
# define	AND_AND	314
# define	OR_OR	315
# define	UMINUS	316
# define	APPLICATION	317

#line 13 "parser.y"


#include "parser.h"
#include "support.h"

#include <gont/runtime.h>
#include "cgont/ast.h"
#include "cgont/cast.h"
#include "cgont/list.h"
#include "cgont/std.h"

#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm
#define YYERROR_VERBOSE 1

#define YYDEBUG 1

/* Constants. */
static struct gont_union *none;
static struct gont_union *nil;
static struct gont_string *empty_string;

/* Used by impl: rule and parse routine. */
static struct gont_union *decls;

/* Defined in support.c. */
extern struct gont_string *input_filename;
struct GontS_Ast__location *make_location(YYLTYPE *l);
void yyerror(const char *msg);

extern YYLTYPE last_lex_loc;

#define make_expr(raw, l) Cast$$make_expr(raw, make_location(l))
#define make_tyvar Cast$$make_tyvar
#define make_located(d, l) Cast$$make_located(d, make_location(l))
#define make_ref_record(x) Cast$$make_ref_record(x)
#define make_vardef(t, n) Cast$$make_vardef(t, n)
#define make_field(t, n) Cast$$make_field(t, n, make_location(&yyloc))
#define make_tydef(name, vars, ty) \
	Cast$$make_tydef(name, vars, ty, make_location(&yyloc))
#define make_fn_decl(header, exportas, body) \
	Cast$$make_fn_decl(header, exportas, body)
#define bare_fn_type(r, a) Cast$$bare_fn_type(r, a)
#define make_vardefs(t, vars) Cast$$make_vardefs(t, vars)
#define make_lambda Cast$$make_lambda
#define make_lambda_assign Cast$$make_lambda_assign
#define make_break Cast$$make_break
#define make_loop Cast$$make_loop
#define make_namedexpr Cast$$make_namedexpr
#define make_sini_expr Cast$$make_sini_expr
#define make_named_type Cast$$make_named_type
#define make_try_record Cast$$make_try_record
#define make_float_const Cast$$make_float_const
#define make_int_const Cast$$make_int_const
#define make_named_pattern Cast$$make_named_pattern
#define make_section_record Cast$$make_section_record
#define make_case_clause Cast$$make_case_clause

#define U(fld, val) \
	gont_make_union(GontUF_Ast__ ## fld, (val))

#define Some(x) \
	gont_make_union(GontUF_Std__Some, (x))

#define P(a, b) \
	gont_make_tuple(2, (a), (b))

#define TRIPLE(a, b, c) \
	gont_make_tuple(3, (a), (b), (c))

#define CONS(a, b) \
	gont_make_union(GontUF_List__Cons, P((a), (b)))

#define EXPR(fld, val) \
	make_expr(U(fld, (val)), &yyloc)

#define BIN(op, e1, e2) \
	EXPR(SimpleBinOp, TRIPLE(U(op, NULL), (e1), (e2)))

#define UNARY(op, e) \
	EXPR(SimpleUnOp, P(U(op, none), e))

#define LOCATED(x) \
	make_located(x, &yyloc)

#define STMT(fld, val) \
	LOCATED(U(fld, (val)))

#define PAIR(a, b) \
	STMT(Pair, P((a), (b)))

#define SKIP() \
	STMT(Skip, NULL)

#define LOOP(lab, body, inc) \
	LOCATED(make_loop(lab, body, inc))
#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;

  int last_line;
  int last_column;
} yyltype;

# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		406
#define	YYFLAG		-32768
#define	YYNTBASE	85

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 317 ? yytranslate[x] : 169)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,     2,     2,    69,     2,     2,
      79,    80,    68,    65,    76,    66,    74,    70,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    83,    75,
      63,    62,    64,     2,    67,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,     2,    82,     2,    84,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    71,    73
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     6,     8,    10,    12,    14,    16,
      18,    20,    22,    24,    26,    29,    32,    35,    37,    40,
      41,    44,    48,    52,    56,    60,    63,    65,    67,    71,
      74,    76,    80,    81,    84,    88,    89,    92,    96,    98,
     101,   108,   115,   122,   127,   131,   133,   135,   137,   139,
     141,   147,   155,   159,   161,   165,   166,   168,   170,   172,
     174,   179,   186,   195,   200,   204,   206,   208,   210,   213,
     215,   219,   220,   222,   228,   231,   236,   238,   242,   243,
     245,   247,   251,   255,   259,   261,   265,   268,   271,   274,
     277,   279,   283,   287,   291,   295,   299,   303,   307,   311,
     315,   319,   323,   326,   330,   335,   338,   340,   343,   347,
     351,   355,   359,   363,   367,   371,   375,   379,   383,   387,
     391,   395,   398,   400,   402,   404,   406,   408,   410,   412,
     414,   416,   418,   422,   424,   426,   430,   434,   436,   440,
     446,   451,   458,   462,   464,   467,   468,   470,   473,   475,
     477,   479,   481,   483,   485,   487,   489,   491,   497,   505,
     513,   515,   519,   521,   525,   528,   530,   532,   534,   535,
     537,   538,   540,   542,   543,   544,   547,   548,   550,   557,
     566,   577,   579,   581,   584,   586,   588,   591,   594,   597,
     599,   603,   607,   613,   615,   618,   621,   624,   625,   629,
     631,   635,   638,   639,   644,   645,   650,   655,   661,   665,
     667,   668,   670,   674,   676,   678,   680,   682,   685
};
static const short yyrhs[] =
{
      -1,    86,    85,     0,    87,     0,    94,     0,    90,     0,
      96,     0,   106,     0,    91,     0,   118,     0,    89,     0,
      88,     0,    95,     0,    75,     0,    35,     5,     0,   100,
      75,     0,    39,   100,     0,     6,     0,     6,    92,     0,
       0,    27,    92,     0,   117,    93,   152,     0,    44,     5,
     152,     0,    16,   117,    75,     0,    16,   100,    75,     0,
     117,   152,     0,     5,     0,    98,     0,     5,    45,     5,
       0,   113,    98,     0,     7,     0,     7,    76,   101,     0,
       0,    63,    64,     0,    63,   101,    64,     0,     0,   103,
      75,     0,   113,    99,   103,     0,   104,     0,   104,   105,
       0,    28,   102,     5,    77,   105,    78,     0,    29,   102,
       5,    77,   105,    78,     0,    30,   102,     5,    77,   105,
      78,     0,    32,   113,   102,     5,     0,    31,   102,     5,
       0,    11,     0,     9,     0,    13,     0,    14,     0,    17,
       0,    68,   113,    79,   116,    80,     0,    68,    79,   113,
      79,   116,    80,    80,     0,   113,    76,   110,     0,   113,
       0,   113,    76,   110,     0,     0,   110,     0,   107,     0,
     108,     0,     7,     0,    63,   111,    64,    99,     0,    51,
     110,    64,    99,    64,    99,     0,    51,   110,    64,    99,
      76,   110,    64,    99,     0,    68,    81,   109,    82,     0,
      79,   112,    80,     0,    99,     0,   112,     0,   113,     0,
     113,     5,     0,   114,     0,   114,    76,   115,     0,     0,
     115,     0,   113,    98,    79,   116,    80,     0,   117,    75,
       0,   117,    62,    92,    75,     0,   127,     0,   127,    76,
     119,     0,     0,   119,     0,    99,     0,   127,    76,   127,
       0,   127,    76,   122,     0,    81,   122,    82,     0,   132,
       0,   127,    62,   127,     0,    54,   127,     0,    53,   127,
       0,   127,    54,     0,   127,    53,     0,   128,     0,   125,
      65,   125,     0,   125,    66,   125,     0,   125,    68,   125,
       0,   125,    70,   125,     0,   125,    69,   125,     0,   125,
      63,   125,     0,   125,    64,   125,     0,   125,    47,   125,
       0,   125,    48,   125,     0,   125,    49,   125,     0,   125,
      50,   125,     0,    66,   125,     0,    99,    81,    82,     0,
      99,    81,   127,    82,     0,    99,   123,     0,   128,     0,
      72,   127,     0,   127,    65,   127,     0,   127,    66,   127,
       0,   127,    68,   127,     0,   127,    70,   127,     0,   127,
      69,   127,     0,   127,    63,   127,     0,   127,    64,   127,
       0,   127,    47,   127,     0,   127,    48,   127,     0,   127,
      49,   127,     0,   127,    50,   127,     0,   127,    60,   127,
       0,   127,    61,   127,     0,    66,   127,     0,   123,     0,
     124,     0,   131,     0,   126,     0,     3,     0,     4,     0,
      92,     0,    33,     0,    34,     0,   121,     0,    79,   127,
      80,     0,   133,     0,    36,     0,   128,    74,    98,     0,
      99,    62,   127,     0,   129,     0,   129,    76,   130,     0,
      79,    77,   130,    78,    80,     0,   128,    79,   120,    80,
       0,    18,   113,    79,   116,    80,   152,     0,    77,   136,
      78,     0,   139,     0,   139,   135,     0,     0,   135,     0,
     151,    75,     0,   134,     0,    97,     0,   150,     0,   162,
       0,   161,     0,   140,     0,   137,     0,   138,     0,   141,
       0,    19,    79,   127,    80,   138,     0,    19,    79,   127,
      80,   141,    20,   139,     0,    19,    79,   127,    80,   137,
      20,   139,     0,    98,     0,    98,    62,   127,     0,   142,
       0,   142,    76,   143,     0,   113,   143,     0,   124,     0,
     144,     0,    12,     0,     0,   127,     0,     0,   124,     0,
      12,     0,     0,     0,     5,    83,     0,     0,    98,     0,
     148,    21,    79,   127,    80,   139,     0,   148,    22,   134,
      21,    79,   127,    80,    75,     0,   148,    23,    79,   145,
      75,   146,    75,   147,    80,   139,     0,   124,     0,    10,
       0,    10,   127,     0,    12,     0,   144,     0,    37,   127,
       0,    40,   149,     0,    41,   149,     0,   134,     0,    79,
     127,    80,     0,    24,   168,    83,     0,    24,   168,    19,
     127,    83,     0,   153,     0,   153,   154,     0,   154,   135,
       0,   155,   156,     0,     0,   168,    62,   127,     0,   157,
       0,   157,    76,   158,     0,    42,   139,     0,     0,    43,
      77,   156,    78,     0,     0,    38,   134,   160,   159,     0,
      26,   158,    15,   139,     0,    25,   127,    77,   156,    78,
       0,   168,    76,   163,     0,   168,     0,     0,   163,     0,
      81,   164,    82,     0,   165,     0,    84,     0,   125,     0,
     165,     0,    99,   166,     0,   167,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   157,   159,   162,   166,   168,   169,   170,   171,   172,
     173,   174,   175,   182,   186,   190,   194,   198,   200,   203,
     205,   208,   214,   221,   223,   226,   234,   238,   240,   243,
     250,   252,   255,   257,   258,   261,   263,   266,   270,   272,
     275,   278,   280,   282,   284,   288,   290,   291,   292,   293,
     296,   299,   303,   307,   309,   312,   314,   317,   319,   320,
     321,   323,   325,   327,   330,   332,   333,   339,   341,   344,
     346,   349,   351,   354,   359,   361,   367,   369,   372,   374,
     377,   381,   383,   386,   391,   393,   394,   395,   396,   397,
     400,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   416,   420,   422,   426,   430,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   452,   455,   457,   458,
     459,   460,   461,   462,   463,   464,   468,   473,   475,   478,
     483,   488,   496,   500,   502,   505,   507,   510,   512,   513,
     514,   515,   516,   519,   519,   520,   520,   522,   527,   530,
     534,   536,   543,   545,   548,   553,   555,   556,   557,   561,
     563,   567,   569,   570,   574,   576,   579,   581,   584,   589,
     593,   604,   606,   607,   608,   609,   610,   611,   613,   617,
     619,   626,   629,   633,   635,   638,   642,   644,   647,   651,
     653,   656,   658,   661,   663,   666,   671,   674,   682,   684,
     687,   689,   692,   696,   700,   702,   703,   704,   708
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "FLOAT", "ID", "STRING", "TYVAR", 
  "CHAR", "KW_INT", "KW_RETURN", "KW_VOID", "KW_SKIP", "KW_BOOL", 
  "KW_FLOAT", "KW_IN", "KW_EXTERN_C", "KW_STRING", "KW_FUN", "KW_IF", 
  "KW_ELSE", "KW_WHILE", "KW_DO", "KW_FOR", "KW_CASE", "KW_SWITCH", 
  "KW_LET", "KW_EXPORT_AS", "KW_STRUCT", "KW_OPT_STRUCT", "KW_UNION", 
  "KW_TYPE", "KW_TYPEDEF", "KW_TRUE", "KW_FALSE", "KW_OPEN", "KW_NULL", 
  "KW_RAISE", "KW_TRY", "KW_EXCEPTION", "KW_BREAK", "KW_CONTINUE", 
  "KW_FINALLY", "KW_WITH", "KW_SECTION", "DOUBLECOLON", "ARROW", "GE", 
  "LE", "EQ", "NE", "LTLT", "GTGT", "PLUS_PLUS", "MINUS_MINUS", 
  "SLASH_EQUAL", "PLUS_EQUAL", "MINUS_EQUAL", "PERCENT_EQUAL", 
  "STAR_EQUAL", "AND_AND", "OR_OR", "'='", "'<'", "'>'", "'+'", "'-'", 
  "'@'", "'*'", "'%'", "'/'", "UMINUS", "'!'", "APPLICATION", "'.'", 
  "';'", "','", "'{'", "'}'", "'('", "')'", "'['", "']'", "':'", "'_'", 
  "module", "decl", "nl_decl", "dummy_decl", "top_open", "global_var", 
  "exn_decl", "string", "maybe_export_as", "func", "section", "extern_c", 
  "func_def", "id", "qid", "vardef", "type_var_list_content", 
  "type_var_list", "maybe_semicolons", "record_type_fld", 
  "record_type_flds", "type_decl", "simple_type", "function_type", 
  "tuple_ty", "ne_ty_list", "ty_list", "xtype_exp", "type_exp", 
  "func_arg", "ne_func_args", "func_args", "func_header", "func_proto", 
  "ne_expr_list", "expr_list", "variable", "tuple_content", "tuple", 
  "stmt_expr", "pattern_expr", "union_expr", "expr", "primary", 
  "struct_init", "struct_expr_content", "struct_expr", "call", "lambda", 
  "block", "ne_stmts", "stmts", "non_if_stmt", "no_else", "stmt", 
  "if_stmt", "if_else_stmt", "single_var_def", "var_def_list", "var_def", 
  "for_exp1", "for_exp2", "for_exp3", "maybe_label", "maybe_id", 
  "loop_stmt", "normal_stmt", "fnc_body", "one_case", "cases", 
  "case_clause", "case_list", "pattern_eq", "pattern_eq_list", 
  "maybe_finally", "maybe_with", "try_stmt", "pattern_matching_stmt", 
  "ne_pattern_list", "pattern_list", "raw_tuple_pattern", "tuple_pattern", 
  "raw_pattern", "pattern", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    85,    85,    86,    87,    87,    87,    87,    87,    87,
      87,    87,    87,    88,    89,    90,    91,    92,    92,    93,
      93,    94,    95,    96,    96,    97,    98,    99,    99,   100,
     101,   101,   102,   102,   102,   103,   103,   104,   105,   105,
     106,   106,   106,   106,   106,   107,   107,   107,   107,   107,
     108,   108,   109,   110,   110,   111,   111,   112,   112,   112,
     112,   112,   112,   112,   113,   113,   113,   114,   114,   115,
     115,   116,   116,   117,   118,   118,   119,   119,   120,   120,
     121,   122,   122,   123,   124,   124,   124,   124,   124,   124,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   126,   126,   126,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   129,   130,   130,   131,
     132,   133,   134,   135,   135,   136,   136,   137,   137,   137,
     137,   137,   137,   138,   138,   139,   139,   140,   141,   141,
     142,   142,   143,   143,   144,   145,   145,   145,   145,   146,
     146,   147,   147,   147,   148,   148,   149,   149,   150,   150,
     150,   151,   151,   151,   151,   151,   151,   151,   151,   152,
     152,   153,   153,   154,   154,   155,   156,   156,   157,   158,
     158,   159,   159,   160,   160,   161,   162,   162,   163,   163,
     164,   164,   165,   166,   167,   167,   167,   167,   168
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     2,     0,
       2,     3,     3,     3,     3,     2,     1,     1,     3,     2,
       1,     3,     0,     2,     3,     0,     2,     3,     1,     2,
       6,     6,     6,     4,     3,     1,     1,     1,     1,     1,
       5,     7,     3,     1,     3,     0,     1,     1,     1,     1,
       4,     6,     8,     4,     3,     1,     1,     1,     2,     1,
       3,     0,     1,     5,     2,     4,     1,     3,     0,     1,
       1,     3,     3,     3,     1,     3,     2,     2,     2,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     4,     2,     1,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     3,     3,     1,     3,     5,
       4,     6,     3,     1,     2,     0,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     7,     7,
       1,     3,     1,     3,     2,     1,     1,     1,     0,     1,
       0,     1,     1,     0,     0,     2,     0,     1,     6,     8,
      10,     1,     1,     2,     1,     1,     2,     2,     2,     1,
       3,     3,     5,     1,     2,     2,     2,     0,     3,     1,
       3,     2,     0,     4,     0,     4,     4,     5,     3,     1,
       0,     1,     3,     1,     1,     1,     1,     2,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,    26,    59,    46,    45,    47,    48,     0,    49,    32,
      32,    32,    32,     0,     0,     0,     0,     0,    55,     0,
      13,     0,     1,     3,    11,    10,     5,     8,     4,    12,
       6,    27,    65,     0,     7,    57,    58,    66,     0,    19,
       9,     0,     0,     0,     0,     0,     0,     0,     0,    32,
      14,    16,     0,     0,     0,    53,    56,     0,     0,     0,
       0,     0,     2,    15,    26,    29,     0,     0,    74,     0,
      28,    24,    23,    30,    33,     0,     0,     0,     0,    44,
       0,    29,   174,     0,   189,    22,     0,     0,     0,    66,
       0,     0,     0,    71,    64,    71,    17,    20,     0,    21,
       0,    34,     0,     0,     0,    43,   126,   127,    26,   182,
     184,     0,     0,     0,     0,   129,   130,   134,     0,     0,
     176,   176,     0,     0,     0,     0,     0,     0,   128,   149,
      80,     0,     0,   131,   122,   123,   125,     0,   106,   124,
      84,   133,   148,   146,     0,   154,   155,   174,   153,   156,
     185,     0,   150,     0,   152,   151,     0,    80,   123,     0,
       0,    54,    60,    71,    63,     0,    67,    69,    72,     0,
       0,    18,    75,    31,    38,     0,     0,     0,     0,   175,
     183,     0,     0,     0,     0,     0,   210,   214,    80,   215,
      90,   199,     0,   216,   218,     0,   186,   204,   177,   187,
     188,    87,    86,   121,   107,     0,     0,     0,     0,     0,
     105,   160,   162,   164,    25,     0,     0,     0,     0,    89,
      88,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,   142,   144,     0,     0,     0,   147,   190,
       0,     0,     0,    52,    68,     0,    50,    73,    39,    40,
      35,    41,    42,    71,     0,   197,    80,   102,   211,     0,
     209,   213,   217,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,     0,     0,   202,     0,
     137,     0,   132,    83,     0,   103,     0,     0,     0,   115,
     116,   117,   118,   119,   120,    85,   113,   114,   108,   109,
     110,   112,   111,   135,    79,     0,    76,     0,     0,   168,
      61,     0,     0,    70,    37,     0,   174,     0,   193,   174,
     197,     0,   212,     0,    98,    99,   100,   101,    96,    97,
      91,    92,    93,    95,    94,   200,   206,   198,   197,   174,
     205,     0,     0,     0,    82,    81,   104,   161,   160,   163,
     140,     0,     0,     0,   167,     0,   123,   166,     0,     0,
      51,    36,     0,   154,   157,     0,     0,   194,   195,   196,
     207,   208,     0,   201,   136,   138,   139,    77,   174,     0,
     170,    62,   141,   174,   174,     0,   191,   203,   178,     0,
     169,     0,   159,   158,     0,     0,   173,   192,   179,   172,
     123,     0,   174,   180,     0,     0,     0
};

static const short yydefgoto[] =
{
      62,    22,    23,    24,    25,    26,    27,   128,    69,    28,
      29,    30,   129,    31,   157,    33,    75,    45,   314,   174,
     175,    34,    35,    36,    91,    54,    57,    37,   131,   167,
     168,   169,   132,    40,   304,   305,   133,   207,   134,   158,
     189,   136,   137,   138,   280,   281,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   212,   213,   150,
     358,   391,   401,   151,   199,   152,   153,    85,   318,   319,
     320,   321,   191,   192,   340,   278,   154,   155,   258,   259,
     193,   262,   194,   195
};

static const short yypact[] =
{
     949,   -20,-32768,-32768,-32768,-32768,-32768,   992,-32768,   -34,
     -34,   -34,   -34,   992,    62,   992,    63,   992,   992,   923,
  -32768,   115,   949,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,     2,-32768,-32768,-32768,-32768,    86,    14,
  -32768,    87,    35,    45,     5,   108,   118,   122,   125,   -34,
  -32768,-32768,    86,    58,    70,   -41,-32768,    74,   992,   992,
      65,    66,-32768,-32768,-32768,    69,   137,   137,-32768,    58,
  -32768,-32768,-32768,    77,-32768,    90,    80,    85,    92,-32768,
     170,-32768,   608,   889,-32768,-32768,   176,   992,   176,    66,
     106,   100,   114,   992,-32768,   992,   137,-32768,   117,-32768,
     186,-32768,   992,   992,   992,-32768,-32768,-32768,   -29,   889,
  -32768,   992,   123,   889,   155,-32768,-32768,-32768,   889,   120,
      86,    86,   889,   889,   889,   889,   766,   889,-32768,-32768,
       9,    86,    58,-32768,-32768,   129,-32768,  1207,    42,-32768,
  -32768,-32768,-32768,-32768,   142,-32768,-32768,   529,-32768,-32768,
  -32768,   192,-32768,   133,-32768,-32768,   867,   143,-32768,  1014,
     -40,-32768,-32768,   992,-32768,   992,   217,   147,-32768,   145,
     149,-32768,-32768,-32768,   992,   152,   176,   159,   164,-32768,
    1207,   154,   889,  1134,    28,   889,   155,-32768,   146,   440,
     175,   174,   236,-32768,-32768,   190,  1207,   212,-32768,-32768,
  -32768,    52,    52,    52,    52,   176,  1038,   177,  1159,   441,
  -32768,     1,   180,-32768,-32768,   889,   889,   889,   889,-32768,
  -32768,   889,   889,   889,   889,   889,   889,   889,   889,   889,
     889,    86,   889,-32768,-32768,   181,   120,   182,-32768,-32768,
     176,   992,   197,-32768,-32768,   992,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,   992,  1062,   233,-32768,-32768,-32768,   196,
     204,-32768,-32768,    28,    28,    28,    28,    28,    28,    28,
      28,    28,    28,    28,   155,   687,   889,   185,   239,   220,
     208,   207,-32768,-32768,   889,-32768,   972,   889,    86,   102,
     102,   178,   178,  1231,  1231,  1207,   102,   102,    31,    31,
      52,    52,    52,-32768,-32768,   206,  1183,   889,   267,   845,
  -32768,   225,   210,-32768,   218,   214,   687,   155,   233,   687,
     233,   221,-32768,   155,   130,   130,   141,   141,   130,   130,
     148,   148,-32768,-32768,-32768,-32768,-32768,  1207,   233,   687,
  -32768,   889,   176,   216,-32768,  1159,-32768,  1207,   238,-32768,
  -32768,   889,  1086,   219,-32768,    86,   226,-32768,   229,   176,
  -32768,-32768,    58,   285,-32768,   286,    -8,-32768,-32768,-32768,
  -32768,-32768,   230,-32768,  1207,-32768,-32768,-32768,   687,   889,
     889,-32768,-32768,   687,   687,   889,-32768,-32768,-32768,  1110,
    1207,   232,-32768,-32768,   743,   235,   446,-32768,-32768,-32768,
     231,   234,   687,-32768,   312,   320,-32768
};

static const short yypgoto[] =
{
     325,-32768,-32768,-32768,-32768,-32768,-32768,   -18,-32768,-32768,
  -32768,-32768,-32768,   -12,     0,    64,   228,    32,-32768,-32768,
     -76,-32768,-32768,-32768,-32768,   -15,-32768,   -11,    38,-32768,
      84,   -89,    30,-32768,   -21,-32768,-32768,    53,  -107,   -81,
     103,-32768,   209,   140,-32768,    -4,-32768,-32768,-32768,   -49,
    -142,-32768,    24,    25,  -266,-32768,    29,-32768,    56,    37,
  -32768,-32768,-32768,-32768,   227,-32768,-32768,   -67,-32768,    33,
  -32768,  -299,-32768,    75,-32768,-32768,-32768,-32768,    27,-32768,
     165,-32768,-32768,  -178
};


#define	YYLAST		1301


static const short yytable[] =
{
      32,   135,    99,    56,    84,   234,   170,    32,   260,   336,
      61,   385,    73,    32,   -65,    32,    41,    32,    32,    32,
      84,   369,    32,   210,   240,    41,    65,   177,   178,    44,
      39,   106,   107,     1,    96,    87,   241,    43,    38,   372,
      81,    66,    46,    47,    48,    38,   111,    89,    97,    98,
     210,    49,    39,    52,   179,    55,    55,    60,    32,    32,
      38,   115,   116,   287,   117,   214,   135,    50,    53,    74,
     197,    42,   161,   373,   242,   386,    67,    63,   171,    51,
      95,    80,   130,    84,   219,   220,   160,    32,   162,    68,
     209,    64,    70,    32,   184,    32,    90,    92,   248,   228,
     229,   230,    32,    32,    32,   219,   220,   185,   198,   198,
      71,    32,   388,    76,   188,    61,   231,   392,   393,   211,
      72,   232,     2,    77,     3,    55,     4,    78,     5,     6,
      79,   166,     8,   166,    86,    82,   403,    83,    88,   366,
     176,   176,   176,    96,    93,   260,    94,   130,    95,   181,
     243,   217,   218,   100,   101,   219,   220,   102,   106,   107,
       1,    96,   103,    32,   315,    32,    17,   226,   227,   104,
     228,   229,   230,   111,    32,   105,   250,   368,    18,   265,
     266,     1,   164,    19,   256,   163,   188,   308,   115,   116,
     165,   117,   172,    73,   135,   269,   270,    82,   271,   272,
     273,   166,   182,    55,  -181,   279,   269,   270,   238,   271,
     272,   273,   176,   235,   236,   237,   271,   272,   273,   303,
     233,   184,   244,   245,   209,   246,   311,   186,   356,   247,
     249,   219,   220,   253,   185,   135,   186,   251,   135,   187,
     310,    32,   252,   226,   227,    32,   228,   229,   230,   231,
     274,   275,   276,    32,   190,   277,   288,   317,   135,   283,
     307,   309,   338,   256,   256,   256,   256,   256,   256,   256,
     256,   256,   256,   256,   188,   130,   348,   312,   322,    55,
     323,   339,   341,   166,   342,   343,   350,   257,   353,   359,
     360,   166,   159,   361,   362,   382,   376,   135,   379,   370,
     287,  -165,   135,   135,   380,   383,   384,   396,   387,   130,
     398,  -171,   405,    84,   402,   400,   130,   188,   180,   130,
     406,   135,   183,   188,   190,   404,   190,   196,   173,   313,
     377,   201,   202,   203,   204,   206,   208,   344,   375,   130,
     363,   364,   279,   348,   349,   365,   357,   355,   200,   335,
     371,   367,     0,   261,     0,     0,     0,     0,     0,   381,
       0,     0,     0,     0,     0,   206,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,     0,   130,     0,
       0,     0,     0,   130,   130,     0,     0,     0,     0,     0,
       0,   254,     0,     0,   206,     0,     0,     0,     0,     0,
       0,     0,   130,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   190,   190,   190,     0,     0,     0,   286,     0,
       0,     0,     0,     0,   289,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
       0,   306,     0,     0,   106,   107,     1,    96,     0,   106,
     107,     1,    96,     0,     0,     0,     0,   190,   399,   111,
       0,     0,     0,   190,   111,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   115,   116,     0,   117,     0,   115,
     116,     0,   117,     0,     0,   337,     0,   263,   264,   265,
     266,     0,     0,   345,   122,   123,   347,     0,     0,   122,
     123,     0,     0,   267,   268,   269,   270,   124,   271,   272,
     273,     0,   124,   125,     0,     0,   352,     0,   125,     0,
     156,     0,   127,   285,     0,   156,     0,   127,     0,     0,
       0,     0,   106,   107,   108,    96,     2,     0,     3,   109,
       4,   110,     5,     6,     0,     0,     8,   111,   112,     0,
     374,     0,     0,  -143,   113,   114,     0,     0,     0,     0,
     306,     0,   115,   116,     0,   117,   118,   119,     0,   120,
     121,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      17,     0,   122,   123,     0,     0,     0,     0,   389,   390,
       0,     0,    18,     0,   394,   124,     0,    19,     0,     0,
       0,   125,     0,     0,     0,     0,    82,  -143,   126,     0,
     127,   106,   107,   108,    96,     2,     0,     3,   109,     4,
     110,     5,     6,     0,     0,     8,   111,   112,     0,     0,
       0,     0,     0,   113,   114,     0,     0,     0,     0,     0,
       0,   115,   116,     0,   117,   118,   119,     0,   120,   121,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    17,
       0,   122,   123,     0,     0,     0,     0,     0,     0,     0,
       0,    18,     0,     0,   124,     0,    19,     0,     0,     0,
     125,     0,     0,     0,     0,    82,  -145,   126,     0,   127,
     106,   107,   108,    96,     2,     0,     3,   109,     4,   110,
       5,     6,     0,     0,     8,   111,   112,     0,     0,     0,
       0,     0,   113,   114,     0,     0,     0,     0,     0,     0,
     115,   116,     0,   117,   118,   119,     0,   120,   121,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    17,     0,
     122,   123,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,   124,     0,    19,     0,     0,     0,   125,
       0,     0,     0,     0,    82,     0,   126,     0,   127,   106,
     107,     1,    96,     2,     0,     3,     0,     4,     0,     5,
       6,     0,     0,     8,   111,     0,     0,     0,     0,     0,
     215,   216,   217,   218,     0,     0,   219,   220,     0,   115,
     116,     0,   117,   221,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,     0,     0,     0,    17,     0,   122,
     123,     0,     0,     0,     0,     0,   397,     0,     0,    18,
       0,     0,   124,     0,    19,     0,     0,     0,   125,     0,
       0,     0,     0,   205,     0,   156,     0,   127,   106,   107,
       1,    96,     2,     0,     3,     0,     4,   354,     5,     6,
       0,     0,     8,   111,     0,     0,     0,     0,     0,     0,
     106,   107,     1,    96,     0,     0,     0,     0,   115,   116,
       0,   117,     0,     0,     0,   111,     0,     0,     0,     0,
       0,     0,   106,   107,     1,    96,    17,     0,   122,   123,
     115,   116,     0,   117,     0,     0,     0,   111,    18,     0,
       0,   124,     0,    19,     0,     0,     0,   125,     0,     0,
     122,   123,   115,   116,   126,   117,   127,     0,     1,     0,
       2,     0,     3,   124,     4,     0,     5,     6,     0,   125,
       8,     0,   122,   123,   205,     0,   156,     0,   127,     0,
       0,     0,     0,     0,     1,   124,     2,     0,     3,     0,
       4,   125,     5,     6,     0,     7,     8,     0,   156,     0,
     127,     0,     0,     0,    17,     0,     0,     9,    10,    11,
      12,    13,     0,     0,    14,     0,    18,     0,    15,     0,
       0,    19,     0,    16,     0,     0,     0,     1,     0,     2,
      17,     3,    58,     4,    59,     5,     6,     0,     0,     8,
       0,     0,    18,     0,     0,     0,     0,    19,     0,   215,
     216,   217,   218,     0,    20,   219,   220,     0,    21,     0,
       0,     0,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,    17,     0,     0,     0,     0,   284,     0,
       0,     0,     0,     0,   346,    18,     0,     0,     0,     0,
      19,   215,   216,   217,   218,     0,     0,   219,   220,     0,
       0,    21,     0,     0,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   215,   216,   217,   218,     0,
       0,   219,   220,     0,   239,     0,     0,     0,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   215,
     216,   217,   218,     0,     0,   219,   220,     0,   282,     0,
       0,     0,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   215,   216,   217,   218,     0,     0,   219,
     220,     0,   316,     0,     0,     0,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   215,   216,   217,
     218,     0,     0,   219,   220,     0,   378,     0,     0,     0,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   215,   216,   217,   218,     0,     0,   219,   220,     0,
     395,     0,     0,     0,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,     0,   215,   216,   217,   218,
       0,   255,   219,   220,     0,     0,     0,     0,     0,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     215,   216,   217,   218,     0,   284,   219,   220,     0,     0,
       0,     0,     0,   221,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   215,   216,   217,   218,     0,   351,
     219,   220,     0,     0,     0,     0,     0,   221,   222,   223,
     224,   225,   226,   227,     0,   228,   229,   230,   215,   216,
     217,   218,     0,     0,   219,   220,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,     0,   228,
     229,   230
};

static const short yycheck[] =
{
       0,    82,    69,    18,    53,   147,    95,     7,   186,   275,
      21,    19,     7,    13,     5,    15,    45,    17,    18,    19,
      69,   320,    22,   130,    64,    45,    38,   103,   104,    63,
       0,     3,     4,     5,     6,    76,    76,     7,     0,   338,
      52,    27,    10,    11,    12,     7,    18,    58,    66,    67,
     157,    13,    22,    15,    83,    17,    18,    19,    58,    59,
      22,    33,    34,    62,    36,   132,   147,     5,     5,    64,
     119,     7,    87,   339,   163,    83,    62,    75,    96,    15,
      79,    49,    82,   132,    53,    54,    86,    87,    88,    75,
      81,     5,     5,    93,    66,    95,    58,    59,   174,    68,
      69,    70,   102,   103,   104,    53,    54,    79,   120,   121,
      75,   111,   378,     5,   114,   126,    74,   383,   384,   131,
      75,    79,     7,     5,     9,    87,    11,     5,    13,    14,
       5,    93,    17,    95,    64,    77,   402,    79,    64,   317,
     102,   103,   104,     6,    79,   323,    80,   147,    79,   111,
     165,    49,    50,    76,    64,    53,    54,    77,     3,     4,
       5,     6,    77,   163,   253,   165,    51,    65,    66,    77,
      68,    69,    70,    18,   174,     5,   176,   319,    63,    49,
      50,     5,    82,    68,   184,    79,   186,   236,    33,    34,
      76,    36,    75,     7,   275,    65,    66,    77,    68,    69,
      70,   163,    79,   165,    75,   205,    65,    66,    75,    68,
      69,    70,   174,    21,    22,    23,    68,    69,    70,   231,
      78,    66,     5,    76,    81,    80,   241,    81,   309,    80,
      78,    53,    54,    79,    79,   316,    81,    78,   319,    84,
     240,   241,    78,    65,    66,   245,    68,    69,    70,    74,
      76,    15,    62,   253,   114,    43,    76,    24,   339,    82,
      79,    79,    77,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   288,    80,    82,   241,
      76,    42,    62,   245,    76,    78,    80,   184,    21,    64,
      80,   253,    83,    75,    80,   362,    80,   378,    79,    78,
      62,    75,   383,   384,    75,    20,    20,    75,    78,   309,
      75,    80,     0,   362,    80,   396,   316,   317,   109,   319,
       0,   402,   113,   323,   184,     0,   186,   118,   100,   245,
     351,   122,   123,   124,   125,   126,   127,   284,   342,   339,
     316,   316,   342,   355,   288,   316,   309,   309,   121,   274,
     323,   318,    -1,   188,    -1,    -1,    -1,    -1,    -1,   359,
      -1,    -1,    -1,    -1,    -1,   156,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,    -1,   378,    -1,
      -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,
      -1,   182,    -1,    -1,   185,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   402,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,   215,   216,   217,   218,    -1,    -1,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,    -1,    -1,     3,     4,     5,     6,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,   317,    12,    18,
      -1,    -1,    -1,   323,    18,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    33,
      34,    -1,    36,    -1,    -1,   276,    -1,    47,    48,    49,
      50,    -1,    -1,   284,    53,    54,   287,    -1,    -1,    53,
      54,    -1,    -1,    63,    64,    65,    66,    66,    68,    69,
      70,    -1,    66,    72,    -1,    -1,   307,    -1,    72,    -1,
      79,    -1,    81,    82,    -1,    79,    -1,    81,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,    -1,     9,    10,
      11,    12,    13,    14,    -1,    -1,    17,    18,    19,    -1,
     341,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
     351,    -1,    33,    34,    -1,    36,    37,    38,    -1,    40,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    53,    54,    -1,    -1,    -1,    -1,   379,   380,
      -1,    -1,    63,    -1,   385,    66,    -1,    68,    -1,    -1,
      -1,    72,    -1,    -1,    -1,    -1,    77,    78,    79,    -1,
      81,     3,     4,     5,     6,     7,    -1,     9,    10,    11,
      12,    13,    14,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    25,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    -1,    40,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    66,    -1,    68,    -1,    -1,    -1,
      72,    -1,    -1,    -1,    -1,    77,    78,    79,    -1,    81,
       3,     4,     5,     6,     7,    -1,     9,    10,    11,    12,
      13,    14,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    -1,    40,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    -1,    66,    -1,    68,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    -1,    77,    -1,    79,    -1,    81,     3,
       4,     5,     6,     7,    -1,     9,    -1,    11,    -1,    13,
      14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,
      47,    48,    49,    50,    -1,    -1,    53,    54,    -1,    33,
      34,    -1,    36,    60,    61,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    -1,    -1,    -1,    51,    -1,    53,
      54,    -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,    63,
      -1,    -1,    66,    -1,    68,    -1,    -1,    -1,    72,    -1,
      -1,    -1,    -1,    77,    -1,    79,    -1,    81,     3,     4,
       5,     6,     7,    -1,     9,    -1,    11,    12,    13,    14,
      -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,    51,    -1,    53,    54,
      33,    34,    -1,    36,    -1,    -1,    -1,    18,    63,    -1,
      -1,    66,    -1,    68,    -1,    -1,    -1,    72,    -1,    -1,
      53,    54,    33,    34,    79,    36,    81,    -1,     5,    -1,
       7,    -1,     9,    66,    11,    -1,    13,    14,    -1,    72,
      17,    -1,    53,    54,    77,    -1,    79,    -1,    81,    -1,
      -1,    -1,    -1,    -1,     5,    66,     7,    -1,     9,    -1,
      11,    72,    13,    14,    -1,    16,    17,    -1,    79,    -1,
      81,    -1,    -1,    -1,    51,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    35,    -1,    63,    -1,    39,    -1,
      -1,    68,    -1,    44,    -1,    -1,    -1,     5,    -1,     7,
      51,     9,    79,    11,    81,    13,    14,    -1,    -1,    17,
      -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,    47,
      48,    49,    50,    -1,    75,    53,    54,    -1,    79,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    51,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    -1,    82,    63,    -1,    -1,    -1,    -1,
      68,    47,    48,    49,    50,    -1,    -1,    53,    54,    -1,
      -1,    79,    -1,    -1,    60,    61,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    47,    48,    49,    50,    -1,
      -1,    53,    54,    -1,    80,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    66,    -1,    68,    69,    70,    47,
      48,    49,    50,    -1,    -1,    53,    54,    -1,    80,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    -1,
      68,    69,    70,    47,    48,    49,    50,    -1,    -1,    53,
      54,    -1,    80,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    47,    48,    49,
      50,    -1,    -1,    53,    54,    -1,    80,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    47,    48,    49,    50,    -1,    -1,    53,    54,    -1,
      80,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      66,    -1,    68,    69,    70,    -1,    47,    48,    49,    50,
      -1,    77,    53,    54,    -1,    -1,    -1,    -1,    -1,    60,
      61,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      47,    48,    49,    50,    -1,    76,    53,    54,    -1,    -1,
      -1,    -1,    -1,    60,    61,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    47,    48,    49,    50,    -1,    76,
      53,    54,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    47,    48,
      49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    -1,    68,
      69,    70
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/misc/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 158 "parser.y"
{ yyval = nil; decls = yyval; ;
    break;}
case 2:
#line 159 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); decls = yyval; ;
    break;}
case 3:
#line 163 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
case 13:
#line 183 "parser.y"
{ yyval = U(DummyDecl, NULL); ;
    break;}
case 14:
#line 187 "parser.y"
{ yyval = U(TopLevelOpen, yyvsp[0]); ;
    break;}
case 15:
#line 191 "parser.y"
{ yyval = U(GlobalDecl, yyvsp[-1]); ;
    break;}
case 16:
#line 195 "parser.y"
{ yyval = U(ExceptionDecl, yyvsp[0]); ;
    break;}
case 17:
#line 199 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 18:
#line 200 "parser.y"
{ yyval = gont_strjoin(yyvsp[-1], yyvsp[0]); ;
    break;}
case 19:
#line 204 "parser.y"
{ yyval = empty_string; ;
    break;}
case 20:
#line 205 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 21:
#line 210 "parser.y"
{ yyval = make_fn_decl(yyvsp[-2], yyvsp[-1], yyvsp[0]); ;
    break;}
case 22:
#line 216 "parser.y"
{ yyval = U(SectionDecl, P(yyvsp[-1], make_section_record(yyvsp[0]))); ;
    break;}
case 23:
#line 222 "parser.y"
{ yyval = U(ExternC, yyvsp[-1]); ;
    break;}
case 24:
#line 223 "parser.y"
{ yyval = U(ExternC, yyvsp[-1]); ;
    break;}
case 25:
#line 228 "parser.y"
{ yyval = LOCATED(make_lambda_assign(yyvsp[-1], yyvsp[0])); ;
    break;}
case 26:
#line 235 "parser.y"
{ yyval = U(SimpleName, yyvsp[0]); ;
    break;}
case 28:
#line 240 "parser.y"
{ yyval = U(QualifiedName, P(yyvsp[-2], yyvsp[0])); ;
    break;}
case 29:
#line 244 "parser.y"
{ yyval = make_vardef(yyvsp[-1], yyvsp[0]); ;
    break;}
case 30:
#line 251 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 31:
#line 252 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]) ;
    break;}
case 32:
#line 256 "parser.y"
{ yyval = nil; ;
    break;}
case 33:
#line 257 "parser.y"
{ yyval = nil; ;
    break;}
case 34:
#line 258 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 35:
#line 262 "parser.y"
{ yyval = nil; ;
    break;}
case 36:
#line 263 "parser.y"
{ yyval = nil; ;
    break;}
case 37:
#line 267 "parser.y"
{ yyval = make_field(yyvsp[-2], yyvsp[-1]); ;
    break;}
case 38:
#line 271 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 39:
#line 272 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 40:
#line 277 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(Struct, yyvsp[-1])); ;
    break;}
case 41:
#line 279 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(OptStruct, yyvsp[-1])); ;
    break;}
case 42:
#line 281 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(Union, yyvsp[-1])); ;
    break;}
case 43:
#line 283 "parser.y"
{ yyval = make_tydef(yyvsp[0], yyvsp[-1], yyvsp[-2]); ;
    break;}
case 44:
#line 285 "parser.y"
{ yyval = make_tydef(yyvsp[0], yyvsp[-1], U(AbstractType, NULL)); ;
    break;}
case 45:
#line 289 "parser.y"
{ yyval = U(Void, NULL); ;
    break;}
case 46:
#line 290 "parser.y"
{ yyval = U(Int, NULL); ;
    break;}
case 47:
#line 291 "parser.y"
{ yyval = U(Bool, NULL); ;
    break;}
case 48:
#line 292 "parser.y"
{ yyval = U(Float, NULL); ;
    break;}
case 49:
#line 293 "parser.y"
{ yyval = U(String, NULL); ;
    break;}
case 50:
#line 298 "parser.y"
{ yyval = bare_fn_type(yyvsp[-3], yyvsp[-1]); ;
    break;}
case 51:
#line 300 "parser.y"
{ yyval = bare_fn_type(yyvsp[-4], yyvsp[-2]); ;
    break;}
case 52:
#line 304 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 53:
#line 308 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 54:
#line 309 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 55:
#line 313 "parser.y"
{ yyval = nil; ;
    break;}
case 56:
#line 314 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 57:
#line 318 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 58:
#line 319 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 59:
#line 320 "parser.y"
{ yyval = make_tyvar(yyvsp[0]); ;
    break;}
case 60:
#line 321 "parser.y"
{ yyval = make_named_type(yyvsp[0], yyvsp[-2]); ;
    break;}
case 61:
#line 324 "parser.y"
{ yyval = make_named_type(yyvsp[0], CONS(make_named_type(yyvsp[-2], yyvsp[-4]), nil)); ;
    break;}
case 62:
#line 326 "parser.y"
{ yyval = make_named_type(yyvsp[0], CONS(make_named_type(yyvsp[-4], yyvsp[-6]), yyvsp[-2])); ;
    break;}
case 63:
#line 327 "parser.y"
{ yyval = U(Tuple, yyvsp[-1]); ;
    break;}
case 64:
#line 331 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 65:
#line 332 "parser.y"
{ yyval = make_named_type(yyvsp[0], nil); ;
    break;}
case 66:
#line 333 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 67:
#line 340 "parser.y"
{ yyval = P(yyvsp[0], none); ;
    break;}
case 68:
#line 341 "parser.y"
{ yyval = P(yyvsp[-1], Some(yyvsp[0])); ;
    break;}
case 69:
#line 345 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 70:
#line 346 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 71:
#line 350 "parser.y"
{ yyval = nil; ;
    break;}
case 72:
#line 351 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 73:
#line 356 "parser.y"
{ yyval = make_vardef(bare_fn_type(yyvsp[-4], yyvsp[-1]), yyvsp[-3]); ;
    break;}
case 74:
#line 360 "parser.y"
{ yyval = U(FuncProto, yyvsp[-1]); ;
    break;}
case 75:
#line 361 "parser.y"
{ yyval = U(XCFuncProto, P(yyvsp[-1], yyvsp[-3])); ;
    break;}
case 76:
#line 368 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 77:
#line 369 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 78:
#line 373 "parser.y"
{ yyval = nil; ;
    break;}
case 79:
#line 374 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 80:
#line 378 "parser.y"
{ yyval = EXPR(Ref, make_ref_record(yyvsp[0])); ;
    break;}
case 81:
#line 382 "parser.y"
{ yyval = CONS(yyvsp[-2], CONS(yyvsp[0], nil)); ;
    break;}
case 82:
#line 383 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 83:
#line 387 "parser.y"
{ yyval = EXPR(TupleExpr, yyvsp[-1]); ;
    break;}
case 84:
#line 392 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 85:
#line 393 "parser.y"
{ yyval = BIN(Assign, yyvsp[-2], yyvsp[0]); ;
    break;}
case 86:
#line 394 "parser.y"
{ yyval = UNARY(PreDec, yyvsp[0]); ;
    break;}
case 87:
#line 395 "parser.y"
{ yyval = UNARY(PreInc, yyvsp[0]); ;
    break;}
case 88:
#line 396 "parser.y"
{ yyval = UNARY(PostDec, yyvsp[-1]); ;
    break;}
case 89:
#line 397 "parser.y"
{ yyval = UNARY(PostInc, yyvsp[-1]); ;
    break;}
case 90:
#line 401 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 91:
#line 402 "parser.y"
{ yyval = BIN(Plus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 92:
#line 403 "parser.y"
{ yyval = BIN(Minus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 93:
#line 404 "parser.y"
{ yyval = BIN(Mult, yyvsp[-2], yyvsp[0]); ;
    break;}
case 94:
#line 405 "parser.y"
{ yyval = BIN(Div, yyvsp[-2], yyvsp[0]); ;
    break;}
case 95:
#line 406 "parser.y"
{ yyval = BIN(Mod, yyvsp[-2], yyvsp[0]); ;
    break;}
case 96:
#line 407 "parser.y"
{ yyval = BIN(Lt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 97:
#line 408 "parser.y"
{ yyval = BIN(Gt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 98:
#line 409 "parser.y"
{ yyval = BIN(Ge, yyvsp[-2], yyvsp[0]); ;
    break;}
case 99:
#line 410 "parser.y"
{ yyval = BIN(Le, yyvsp[-2], yyvsp[0]); ;
    break;}
case 100:
#line 411 "parser.y"
{ yyval = BIN(Eq, yyvsp[-2], yyvsp[0]); ;
    break;}
case 101:
#line 412 "parser.y"
{ yyval = BIN(Ne, yyvsp[-2], yyvsp[0]); ;
    break;}
case 102:
#line 413 "parser.y"
{ yyval = UNARY(Negate, yyvsp[0]); ;
    break;}
case 103:
#line 419 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-2], EXPR(VoidConst, NULL))); ;
    break;}
case 104:
#line 421 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 105:
#line 423 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-1], yyvsp[0])); ;
    break;}
case 106:
#line 427 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 107:
#line 430 "parser.y"
{ yyval = BIN(Eq, yyvsp[0], 
					   EXPR(BoolConst, (void*)0)); ;
    break;}
case 108:
#line 432 "parser.y"
{ yyval = BIN(Plus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 109:
#line 433 "parser.y"
{ yyval = BIN(Minus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 110:
#line 434 "parser.y"
{ yyval = BIN(Mult, yyvsp[-2], yyvsp[0]); ;
    break;}
case 111:
#line 435 "parser.y"
{ yyval = BIN(Div, yyvsp[-2], yyvsp[0]); ;
    break;}
case 112:
#line 436 "parser.y"
{ yyval = BIN(Mod, yyvsp[-2], yyvsp[0]); ;
    break;}
case 113:
#line 437 "parser.y"
{ yyval = BIN(Lt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 114:
#line 438 "parser.y"
{ yyval = BIN(Gt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 115:
#line 439 "parser.y"
{ yyval = BIN(Ge, yyvsp[-2], yyvsp[0]); ;
    break;}
case 116:
#line 440 "parser.y"
{ yyval = BIN(Le, yyvsp[-2], yyvsp[0]); ;
    break;}
case 117:
#line 441 "parser.y"
{ yyval = BIN(Eq, yyvsp[-2], yyvsp[0]); ;
    break;}
case 118:
#line 442 "parser.y"
{ yyval = BIN(Ne, yyvsp[-2], yyvsp[0]); ;
    break;}
case 119:
#line 443 "parser.y"
{ yyval = BIN(AndIf, yyvsp[-2], yyvsp[0]); ;
    break;}
case 120:
#line 444 "parser.y"
{ yyval = BIN(OrIf, yyvsp[-2], yyvsp[0]); ;
    break;}
case 121:
#line 445 "parser.y"
{ yyval = UNARY(Negate, yyvsp[0]); ;
    break;}
case 122:
#line 446 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 123:
#line 447 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 124:
#line 448 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 125:
#line 449 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 126:
#line 454 "parser.y"
{ yyval = make_int_const(yyvsp[0], make_location(&yyloc)) ;
    break;}
case 127:
#line 456 "parser.y"
{ yyval = make_float_const(yyvsp[0], make_location(&yyloc)) ;
    break;}
case 128:
#line 457 "parser.y"
{ yyval = EXPR(StringConst, yyvsp[0]); ;
    break;}
case 129:
#line 458 "parser.y"
{ yyval = EXPR(BoolConst, (void*)1); ;
    break;}
case 130:
#line 459 "parser.y"
{ yyval = EXPR(BoolConst, (void*)0); ;
    break;}
case 131:
#line 460 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 132:
#line 461 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 133:
#line 462 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 134:
#line 463 "parser.y"
{ yyval = EXPR(NullConst, NULL); ;
    break;}
case 135:
#line 465 "parser.y"
{ yyval = EXPR(DotExpr, make_sini_expr(yyvsp[0], yyvsp[-2])); ;
    break;}
case 136:
#line 470 "parser.y"
{ yyval = make_sini_expr(yyvsp[-2], yyvsp[0]); ;
    break;}
case 137:
#line 474 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 138:
#line 475 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 139:
#line 480 "parser.y"
{ yyval = EXPR(StructExpr, yyvsp[-2]) ;
    break;}
case 140:
#line 485 "parser.y"
{ yyval = EXPR(Call, P(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 141:
#line 490 "parser.y"
{ yyval = LOCATED(make_lambda(bare_fn_type(yyvsp[-4], yyvsp[-2]), yyvsp[0])); ;
    break;}
case 142:
#line 497 "parser.y"
{ yyval = STMT(Block, yyvsp[-1]); ;
    break;}
case 143:
#line 501 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 144:
#line 502 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 145:
#line 506 "parser.y"
{ yyval = nil; ;
    break;}
case 146:
#line 507 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 157:
#line 524 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-2], yyvsp[0], SKIP())); ;
    break;}
case 158:
#line 529 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-4], yyvsp[-2], yyvsp[0])); ;
    break;}
case 159:
#line 531 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-4], yyvsp[-2], yyvsp[0])); ;
    break;}
case 160:
#line 535 "parser.y"
{ yyval = P(yyvsp[0], SKIP()); ;
    break;}
case 161:
#line 537 "parser.y"
{ yyval = P(yyvsp[-2], STMT(Expr, BIN(Assign,
				    EXPR(Ref, make_ref_record(yyvsp[-2])),
				    yyvsp[0]))); ;
    break;}
case 162:
#line 544 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 163:
#line 545 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 164:
#line 549 "parser.y"
{ yyval = make_vardefs(yyvsp[-1], yyvsp[0]); ;
    break;}
case 165:
#line 554 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]); ;
    break;}
case 166:
#line 555 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 167:
#line 556 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 168:
#line 558 "parser.y"
{ yyval = make_located(U(Skip, NULL), &last_lex_loc); ;
    break;}
case 169:
#line 562 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 170:
#line 564 "parser.y"
{ yyval = make_expr(U(BoolConst, (void*)1), &last_lex_loc); ;
    break;}
case 171:
#line 568 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]) ;
    break;}
case 172:
#line 569 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 173:
#line 571 "parser.y"
{ yyval = make_located(U(Skip, NULL), &last_lex_loc); ;
    break;}
case 174:
#line 575 "parser.y"
{ yyval = empty_string; ;
    break;}
case 175:
#line 576 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 176:
#line 580 "parser.y"
{ yyval = U(SimpleName, empty_string); ;
    break;}
case 177:
#line 581 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 178:
#line 586 "parser.y"
{ yyval = LOOP(yyvsp[-5],
		     PAIR(STMT(BreakIfNot, yyvsp[-2]), yyvsp[0]),
		     SKIP()); ;
    break;}
case 179:
#line 590 "parser.y"
{ yyval = LOOP(yyvsp[-7],
		      PAIR(yyvsp[-5], STMT(BreakIfNot, yyvsp[-2])),
		      SKIP()); ;
    break;}
case 180:
#line 597 "parser.y"
{ yyval = STMT(Block, CONS(yyvsp[-6],
				  CONS(LOOP(yyvsp[-9],
					    PAIR(STMT(BreakIfNot, yyvsp[-4]), yyvsp[0]),
					    yyvsp[-2]),
				       nil))); ;
    break;}
case 181:
#line 605 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]); ;
    break;}
case 182:
#line 606 "parser.y"
{ yyval = STMT(Return, EXPR(VoidConst, NULL)); ;
    break;}
case 183:
#line 607 "parser.y"
{ yyval = STMT(Return, yyvsp[0]); ;
    break;}
case 184:
#line 608 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 185:
#line 609 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 186:
#line 610 "parser.y"
{ yyval = STMT(Raise, yyvsp[0]); ;
    break;}
case 187:
#line 612 "parser.y"
{ yyval = LOCATED(make_break(U(BreakKind, NULL), yyvsp[0])); ;
    break;}
case 188:
#line 614 "parser.y"
{ yyval = LOCATED(make_break(U(ContinueKind, NULL), yyvsp[0])); ;
    break;}
case 189:
#line 618 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 190:
#line 619 "parser.y"
{ yyval = STMT(Block, CONS(STMT(Return, yyvsp[-1]), nil)); ;
    break;}
case 191:
#line 628 "parser.y"
{ yyval = P(yyvsp[-1], EXPR(BoolConst, (void*)1)); ;
    break;}
case 192:
#line 630 "parser.y"
{ yyval = P(yyvsp[-3], yyvsp[-1]); ;
    break;}
case 193:
#line 634 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 194:
#line 635 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 195:
#line 639 "parser.y"
{ yyval = make_case_clause(yyvsp[-1], STMT(Block, yyvsp[0])); ;
    break;}
case 196:
#line 643 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 197:
#line 644 "parser.y"
{ yyval = nil; ;
    break;}
case 198:
#line 648 "parser.y"
{ yyval = P(yyvsp[-2], yyvsp[0]); ;
    break;}
case 199:
#line 652 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 200:
#line 653 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 201:
#line 657 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 202:
#line 658 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 203:
#line 662 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 204:
#line 663 "parser.y"
{ yyval = nil; ;
    break;}
case 205:
#line 668 "parser.y"
{ yyval = STMT(Try, make_try_record(yyvsp[-2], yyvsp[-1], yyvsp[0])); ;
    break;}
case 206:
#line 673 "parser.y"
{ yyval = STMT(Let, P(yyvsp[-2], yyvsp[0])); ;
    break;}
case 207:
#line 675 "parser.y"
{ yyval = STMT(Switch, P(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 208:
#line 683 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 209:
#line 684 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 210:
#line 688 "parser.y"
{ yyval = nil; ;
    break;}
case 211:
#line 689 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 212:
#line 693 "parser.y"
{ yyval = U(TuplePattern, yyvsp[-1]); ;
    break;}
case 213:
#line 697 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
case 214:
#line 701 "parser.y"
{ yyval = U(VoidPattern, NULL); ;
    break;}
case 215:
#line 702 "parser.y"
{ yyval = U(ExprPattern, yyvsp[0]); ;
    break;}
case 216:
#line 703 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 217:
#line 705 "parser.y"
{ yyval = U(UnionPattern, make_named_pattern(yyvsp[-1], yyvsp[0])); ;
    break;}
case 218:
#line 709 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
}

#line 705 "/usr/share/misc/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 712 "parser.y"


struct gont_union *parse(struct gont_string *file)
{
	void *lex = make_lexer(file->data);

	/* yydebug = 1; */

	if (none == NULL) {
		none = gont_make_union(GontUF_Std__None, NULL);
		nil = gont_make_union(GontUF_List__Nil, NULL);
		empty_string = gont_make_string(0, NULL);
	}

	input_filename = gont_make_string(file->len, file->data);

	if (yyparse(lex)) {
		/* We should never get here... */
		yyerror("parse error");
	}

	return decls;
}
